#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int dig [1000000];

string mult (const string& a, const string& b)
{
    string res (a.size() + b.size(), '0');
    for (int ptr_b = b.size() - 1; ptr_b >= 0; ptr_b--)
    {
        int carry = 0;
        for (int ptr_a = a.size() - 1; ptr_a >= 0; ptr_a--)
        {
            int x = a[ptr_a] - '0';
            int y = b[ptr_b] - '0';
            int t = x * y + carry + res[ptr_a + ptr_b + 1] - '0';
            res[ptr_a + ptr_b + 1] = t % 10 + '0';
            carry = t / 10;
        }
        res[ptr_b] = carry + '0';
    }
    reverse (res.begin(), res.end());
    while (res[res.size() - 1] == '0')
    {
        res.erase(res.size() - 1, 1);
    }
    reverse (res.begin(), res.end());
    return res;
}

int mod (string a, int d)
{
    int temp = 0, j = 0;
    for (int i = 0; i < a.size(); i++)
    {
        while (temp < d)
        {
            temp = temp * 10 + (a[j] - '0');
            j++;
        }
        temp = temp * 10 + (a[j] - '0');
        temp %= d;
        i = j;
    }
    return temp;
}

int main ()
{
    int n, p, m, d, temp = 1, cnt = 0;
    cin >> n >> p >> m >> d;

    string digits;
    for (int i = 1; i < m; i++) digits += to_string (i);
    string a = digits.substr (n - 1, p - n + 1);
    string b = digits.substr (n - 1, m - n + 1);
    cout << a << endl;

    string mul = "1";
    for (int i = 0; i < b.size(); i++)
    {
        if (b[i] != '0') mul = mult (mul, to_string(b[i] - '0'));
        dig[b[i] - '0']++;
    }
    cout << mod (mul, d) << endl;

    for (int i = 0; i < 10; i++)
    {
        cout << dig[i] << ' ';
    }

    return 0;
}


