#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int dig [1000000];

string mult (const string& a, const string& b)
{
    string res (a.size() + b.size(), '0');
    for (int ptr_b = b.size() - 1; ptr_b >= 0; ptr_b--)
    {
        int carry = 0;
        for (int ptr_a = a.size() - 1; ptr_a >= 0; ptr_a--)
        {
            int x = a[ptr_a] - '0';
            int y = b[ptr_b] - '0';
            int t = x * y + carry + res[ptr_a + ptr_b + 1] - '0';
            res[ptr_a + ptr_b + 1] = t % 10 + '0';
            carry = t / 10;
        }
        res[ptr_b] = carry + '0';
    }
    reverse (res.begin(), res.end());
    while (res[res.size() - 1] == '0')
    {
        res.erase(res.size() - 1, 1);
    }
    reverse (res.begin(), res.end());
    return res;
}

int mod (string a, int d)
{
    int temp = 0, j = 0;
    for (int i = 0; i < a.size(); i++)
    {
        while (temp < d)
        {
            temp = temp * 10 + (a[j] - '0');
            j++;
        }
        temp %= d;
        i = j;
    }
    temp = temp * 10 + (a[j] - '0');
    temp %= d;
    return temp;
}

int main ()
{
    int n, p, m, d, temp = 1, cnt = 0;
    cin >> n >> p >> m >> d;

    bool flag = true;
    string a, b;
    while (1)
    {
        int f = temp;
        while (f)
        {
            cnt++;
            if (n <= cnt && cnt < p)
            {
                a += ((f % 10) + '0');
                b += ((f % 10) + '0');
            }
            else if (n <= cnt && cnt < m)
            {
                b += ((f % 10) + '0');
            }
            else if (cnt >= m){
                flag = false;
                break;
            }

            f /= 10;
        }
        if (!flag) break;
        temp++;
    }

    cout << a << endl;

    string mul = "1";
    for (int i = 0; i < b.size(); i++)
    {
        if (b[i] != '0') mul = mult (mul, to_string(b[i] - '0'));
        dig[b[i] - '0']++;
    }
    cout << mod (mul, d) << endl;

    for (int i = 0; i < 10; i++)
    {
        cout << dig[i] << ' ';
    }

    return 0;
}



