#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int dig [10];

string mult (const string& a, const string& b)
{
    string res (a.size() + b.size(), '0');
    for (int ptr_b = b.size() - 1; ptr_b >= 0; ptr_b--)
    {
        int carry = 0;
        for (int ptr_a = a.size() - 1; ptr_a >= 0; ptr_a--)
        {
            int x = a[ptr_a] - '0';
            int y = b[ptr_b] - '0';
            int t = x * y + carry + res[ptr_a + ptr_b + 1] - '0';
            res[ptr_a + ptr_b + 1] = t % 10 + '0';
            carry = t / 10;
        }
        res[ptr_b] = carry + '0';
    }
    reverse (res.begin(), res.end());
    while (res[res.size() - 1] == '0')
    {
        res.erase(res.size() - 1, 1);
    }
    reverse (res.begin(), res.end());
    return res;
}

/*string mult (string a, int b)
{
    string res;
    int carry = 0;
    for (int i = a.size() - 1; i >= 0; i--)
    {
        int t = (a[i] - '0') * b + carry;
        if (t > 9)
        {
            carry = t / 10;
            t %= 10;
        }
        res += t + '0';
    }
    if (carry > 0)
    {
        res += carry + '0';
    }
    reverse (res.begin(), res.end());
    return res;
}*/

int mod (string a, int d)
{
    int temp = 0, j = 0;
    for (int i = 0; i < a.size(); i++)
    {
        while (temp < d)
        {
            temp = temp * 10 + (a[j] - '0');
            j++;
        }
        temp %= d;
        i = j;
    }
    temp = temp * 10 + (a[j] - '0');
    temp %= d;
    return temp;
}

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, p, m, d, temp = 1, cnt = 0;
    string mul = "1";
    cin >> n >> p >> m >> d;

    while (1)
    {
        int f = temp;
        while (f)
        {
            cnt++;
            if (n <= cnt && cnt <= p)
            {
                cout << f%10;
                mul = mult (mul, f % 10);
                dig [f % 10]++;
            }
            else if (n <= cnt && cnt <= m)
            {
                mul = mult (mul, f % 10);
                dig[f % 10] ++;
            }
            else if (cnt > m) break;
            f /= 10;
        }
        temp++;
    }
    cout << mod (mul, d) << endl;
    for (int i = 0; i < 10; i++)
    {
        cout << dig[i] << ' ';
    }

    return 0;
}
